> ## Documentation Index
> Fetch the complete documentation index at: https://docs.scrapio.dev/llms.txt
> Use this file to discover all available pages before exploring further.

# Search Walmart

> Search Walmart and return structured results for the first page of matches.



## OpenAPI

````yaml get /v1/walmart/search
openapi: 3.1.0
info:
  title: Scrapio
  version: 1.0.0
  description: >-
    Turn any URL into structured data. Fetch raw HTML, crawl sites, extract
    structured content, interact with dynamic pages, and search the web through
    one API.
  contact:
    name: Scrapio Support
    url: https://scrapio.dev
  license:
    name: Proprietary
servers:
  - url: https://api.scrapio.dev
    description: Production
security:
  - bearerAuth: []
tags:
  - name: System
  - name: Fetch
  - name: Crawl
  - name: Map
  - name: Interact
  - name: Search
  - name: Google
  - name: Fast Search
  - name: Jobs
  - name: YouTube
  - name: Amazon
  - name: Walmart
  - name: Booking
  - name: Agoda
  - name: Airbnb
  - name: ChatGPT
  - name: Perplexity
  - name: Gemini
  - name: Bing
  - name: Reddit
  - name: TikTok
  - name: Apple App Store
  - name: Target
  - name: Monitors
paths:
  /v1/walmart/search:
    get:
      tags:
        - Walmart
      summary: Search Walmart
      description: >-
        Search Walmart and return structured results for the first page: product
        names, item IDs, prices, ratings, and image URLs. For multi-page
        searches, use the `/v1/walmart/search/crawl` async endpoint.
      operationId: searchWalmart
      parameters:
        - name: search
          in: query
          required: true
          schema:
            type: string
            minLength: 1
            description: Search query text
        - name: delivery_zip
          in: query
          required: false
          schema:
            description: Delivery zip code for localized results
            type: string
            minLength: 1
        - name: zip_code
          in: query
          required: false
          schema:
            description: Zip code for localized results
            type: string
            minLength: 1
        - name: store_id
          in: query
          required: false
          schema:
            description: Store id to localize results to
            type: string
            minLength: 1
        - name: sort_by
          in: query
          required: false
          schema:
            description: Sort order for results
            type: string
            minLength: 1
        - name: min_price
          in: query
          required: false
          schema:
            description: Minimum price filter
            type: string
            pattern: ^\d+$
        - name: max_price
          in: query
          required: false
          schema:
            description: Maximum price filter
            type: string
            pattern: ^\d+$
        - name: page
          in: query
          required: false
          schema:
            description: Result page number
            type: string
            pattern: ^\d+$
        - name: pages
          in: query
          required: false
          schema:
            description: Number of pages to fetch, max 5
            type: string
            pattern: ^\d+$
        - name: fulfillment_speed
          in: query
          required: false
          schema:
            description: Fulfillment speed filter
            type: string
            minLength: 1
        - name: fulfillment_type
          in: query
          required: false
          schema:
            description: Fulfillment type filter
            type: string
            minLength: 1
        - name: device
          in: query
          required: false
          schema:
            type: string
            enum:
              - desktop
              - mobile
              - tablet
            description: Device profile to emulate
        - name: timeout_ms
          in: query
          required: false
          schema:
            description: Max time to wait, in ms
            type: string
            pattern: ^\d+$
      responses:
        '200':
          description: Structured Walmart search results.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/WalmartSearchResponse'
        '400':
          description: Invalid search parameters.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
        '401':
          description: Missing or invalid API key.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
        '502':
          description: Walmart blocked the request.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
        '503':
          description: Walmart execution backend unavailable.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
      x-codeSamples:
        - lang: cURL
          label: cURL
          source: >-
            curl "https://api.scrapio.dev/v1/walmart/search?query=coffee+maker"
            \
              -H "Authorization: Bearer $SCRAPIO_API_KEY"
        - lang: Python
          label: Python
          source: |-
            import os, requests
            resp = requests.get(
                "https://api.scrapio.dev/v1/walmart/search",
                headers={"Authorization": f"Bearer {os.environ['SCRAPIO_API_KEY']}"},
                params={"query": "coffee maker"},
            )
            for r in resp.json()["results"]:
                print(r["name"], r["price"])
        - lang: JavaScript
          label: Node.js
          source: >-
            const params = new URLSearchParams({ query: "coffee maker" });

            const { results } = await
            fetch(`https://api.scrapio.dev/v1/walmart/search?${params}`, {
              headers: { Authorization: `Bearer ${process.env.SCRAPIO_API_KEY}` },
            }).then(r => r.json());

            results.forEach(r => console.log(r.name, r.price));
components:
  schemas:
    WalmartSearchResponse:
      type: object
      properties:
        provider:
          type: string
          enum:
            - walmart
        page_type:
          type: string
          enum:
            - search
        meta_data:
          type: object
          properties:
            url:
              type: string
              format: uri
            query:
              anyOf:
                - type: string
                - type: 'null'
            start_page:
              type: integer
              exclusiveMinimum: 0
              maximum: 9007199254740991
            page:
              type: integer
              exclusiveMinimum: 0
              maximum: 9007199254740991
            end_page:
              type: integer
              exclusiveMinimum: 0
              maximum: 9007199254740991
            pages_requested:
              type: integer
              exclusiveMinimum: 0
              maximum: 9007199254740991
            pages_returned:
              type: integer
              exclusiveMinimum: 0
              maximum: 9007199254740991
            number_of_results:
              anyOf:
                - type: number
                - type: 'null'
            number_of_products:
              type: integer
              minimum: 0
              maximum: 9007199254740991
            total_pages:
              anyOf:
                - type: number
                - type: 'null'
          required:
            - url
            - query
            - start_page
            - end_page
            - pages_requested
            - pages_returned
            - number_of_results
            - number_of_products
            - total_pages
          additionalProperties: false
        products:
          type: array
          items:
            type: object
            properties:
              position:
                type: integer
                exclusiveMinimum: 0
                maximum: 9007199254740991
              product_id:
                anyOf:
                  - type: string
                  - type: 'null'
              title:
                anyOf:
                  - type: string
                  - type: 'null'
              price:
                anyOf:
                  - type: number
                  - type: 'null'
              currency:
                anyOf:
                  - type: string
                  - type: 'null'
              rating:
                anyOf:
                  - type: number
                  - type: 'null'
              review_count:
                anyOf:
                  - type: number
                  - type: 'null'
              availability:
                anyOf:
                  - type: string
                  - type: 'null'
              image:
                anyOf:
                  - type: string
                  - type: 'null'
              url:
                type: string
                format: uri
              brand:
                anyOf:
                  - type: string
                  - type: 'null'
              seller:
                anyOf:
                  - type: string
                  - type: 'null'
              free_shipping:
                type: boolean
              two_day_shipping:
                type: boolean
            required:
              - position
              - product_id
              - title
              - price
              - currency
              - rating
              - review_count
              - availability
              - image
              - url
              - brand
              - seller
              - free_shipping
              - two_day_shipping
            additionalProperties: false
        facets:
          type: object
          properties:
            brands:
              type: array
              items:
                type: object
                properties:
                  name:
                    type: string
                  count:
                    anyOf:
                      - type: number
                      - type: 'null'
                required:
                  - name
                  - count
                additionalProperties: false
            ratings:
              type: array
              items:
                type: object
                properties:
                  stars:
                    type: integer
                    exclusiveMinimum: 0
                    maximum: 9007199254740991
                  count:
                    anyOf:
                      - type: number
                      - type: 'null'
                required:
                  - stars
                  - count
                additionalProperties: false
            price_ranges:
              type: array
              items:
                type: object
                properties:
                  min:
                    anyOf:
                      - type: number
                      - type: 'null'
                  max:
                    anyOf:
                      - type: number
                      - type: 'null'
                  count:
                    anyOf:
                      - type: number
                      - type: 'null'
                required:
                  - min
                  - max
                  - count
                additionalProperties: false
            applied_filters:
              type: object
              properties:
                sort_by:
                  anyOf:
                    - type: string
                    - type: 'null'
                min_price:
                  anyOf:
                    - type: number
                    - type: 'null'
                max_price:
                  anyOf:
                    - type: number
                    - type: 'null'
                fulfillment_speed:
                  anyOf:
                    - type: string
                    - type: 'null'
                fulfillment_type:
                  anyOf:
                    - type: string
                    - type: 'null'
              required:
                - sort_by
                - min_price
                - max_price
                - fulfillment_speed
                - fulfillment_type
              additionalProperties: false
          required:
            - brands
            - ratings
            - price_ranges
            - applied_filters
          additionalProperties: false
        location:
          type: object
          properties:
            delivery_zip:
              anyOf:
                - type: string
                - type: 'null'
            zip_code:
              anyOf:
                - type: string
                - type: 'null'
            store_id:
              anyOf:
                - type: string
                - type: 'null'
            domain:
              anyOf:
                - type: string
                - type: 'null'
          required:
            - delivery_zip
            - store_id
            - domain
          additionalProperties: false
      required:
        - provider
        - page_type
        - meta_data
        - products
        - facets
        - location
      additionalProperties: false
    ErrorResponse:
      type: object
      properties:
        request_id:
          type: string
        error:
          type: object
          properties:
            code:
              type: string
            message:
              type: string
          required:
            - code
            - message
        diagnostics:
          type: object
          properties:
            outcome:
              type: string
              enum:
                - failed
            retryable:
              type: boolean
            blocked:
              type: boolean
            timed_out:
              type: boolean
          required:
            - outcome
            - retryable
          additionalProperties: false
      required:
        - request_id
        - error
      additionalProperties: false
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
      bearerFormat: API Key

````